unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Mask, Vcl.ComCtrls,
  Vcl.ExtCtrls, UnitDllDefs, Vcl.Menus;

type
  TSyncTemp = Record
    config : Byte;
    ftemp : Single;
  end;

  TSingleAndBytes = Record
    case boolean of
      false : (fdat : Single);
      true  : (u8dat : Array [0..3] Of Byte);
  end;

  Tfmmain = class(TForm)
    StatusBar: TStatusBar;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    ed_server_port: TEdit;
    BtnSetServerValues: TButton;
    ed_server_ip: TMaskEdit;
    GroupBox5: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lbgar: TLabel;
    lbsubr: TLabel;
    lbshar: TLabel;
    lbip: TLabel;
    lbtcpport: TLabel;
    lbudpport: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    lbkpalive: TLabel;
    lbphycheck: TLabel;
    Label5: TLabel;
    lbvmkpalive: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    lbvmtcpport: TLabel;
    lbvmudpport: TLabel;
    btn_read_settings: TButton;
    Memo: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    ClearMemo1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog2: TOpenDialog;
    TabSheet1: TTabSheet;
    btn_vmstart: TButton;
    btn_get_vmstate: TButton;
    lb_vmstate: TLabel;
    btn_vmirq: TButton;
    ed_vmirq: TEdit;
    btn_irqresult: TButton;
    Button1: TButton;
    btn_vmflash: TButton;
    btn_vmreset: TButton;
    btn_codeloaded: TButton;
    btn_GetParam: TButton;
    btn_SaveParam: TButton;
    btn_LoadFromEEP: TButton;
    btn_LoadToEEP: TButton;
    ed_flashaddr: TEdit;
    ed_pagesize: TEdit;
    ed_eepflashaddr: TEdit;
    Label25: TLabel;
    Label24: TLabel;
    Label23: TLabel;
    cb_loadvm: TCheckBox;
    cb_runvm: TCheckBox;
    btn_vmstop: TButton;
    TabSheet3: TTabSheet;
    lb_temp: TLabel;
    lb_th: TLabel;
    lb_tl: TLabel;
    btn_set_th: TButton;
    ed_th: TEdit;
    btn_set_tl: TButton;
    ed_tl: TEdit;
    btn_get_th: TButton;
    btn_get_tl: TButton;
    rb_flag: TRadioButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure ClearMemo1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btn_vmstartClick(Sender: TObject);
    procedure btn_vmstopClick(Sender: TObject);
    procedure btn_get_vmstateClick(Sender: TObject);
    procedure btn_vmirqClick(Sender: TObject);
    procedure btn_irqresultClick(Sender: TObject);
    procedure btn_vmflashClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btn_LoadToEEPClick(Sender: TObject);
    procedure btn_LoadFromEEPClick(Sender: TObject);
    procedure btn_SaveParamClick(Sender: TObject);
    procedure btn_GetParamClick(Sender: TObject);
    procedure BtnSetServerValuesClick(Sender: TObject);
    procedure btn_read_settingsClick(Sender: TObject);
    procedure btn_vmresetClick(Sender: TObject);
    procedure btn_codeloadedClick(Sender: TObject);
    procedure btn_get_thClick(Sender: TObject);
    procedure btn_get_tlClick(Sender: TObject);
    procedure btn_set_thClick(Sender: TObject);
    procedure btn_set_tlClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SynchronizeCallback(var Message: TMessage); message WM_USER + 1;
  public
    { Public-Deklarationen }
    procedure tomemo(stxt : String; lastline : Boolean = false);
    procedure memoclear;
    function DWORDTosIP(dwIP: DWORD): String;
    function GetIPBytes(sIP : String; iPosi : Byte) : Byte;
  end;
  procedure VM8051Event(const vmdata : Pointer; wSize : word); stdcall;
  procedure VMFlashCallBack(fl0, fl : Word; dwErr :DWORD); stdcall;

var
  fmmain: Tfmmain;
  sServer  : String;
  wTCPPort : Word;

  SyncTemp : TSyncTemp;

implementation

{$R *.dfm}

procedure Tfmmain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  rb_flag.Checked := false;
end;

procedure Tfmmain.SynchronizeCallback(var Message: TMessage);
var stri : String;
begin
  rb_flag.Checked := true;
  Timer1.Enabled := true;
  if Message.wParam = 1 then
  begin
    case Message.lParam of
    $20: begin
           lb_tl.Caption := Format('%.2f C', [SyncTemp.ftemp]);
         end;
    $21: begin
           lb_th.Caption := Format('%.2f C', [SyncTemp.ftemp]);
         end;
    $AA: begin
           if (SyncTemp.config and $20 = $20) then
           begin
             lb_temp.Font.Color := clBlue;
             stri := '%.4f C (TLF)';
           end else if (SyncTemp.config and $40 = $40) then
           begin
             lb_temp.Font.Color := clRed;
             stri := '%.4f C (THF)';
           end else
           begin
             lb_temp.Font.Color := clBlack;
             stri := '%.4f C';
           end;
           lb_temp.Caption := Format(stri, [SyncTemp.ftemp]);
         end;
    end;
  end;
end;

procedure VM8051Event(const vmdata : Pointer; wSize : word);
var temp : TSingleAndBytes;
    cmd : Byte;
begin
  cmd := PByte(vmdata)[0];
  case cmd of
  $20: begin
         if wSize = 5 then
         begin
           temp.u8dat[0] := PByte(vmdata)[1];
           temp.u8dat[1] := PByte(vmdata)[2];
           temp.u8dat[2] := PByte(vmdata)[3];
           temp.u8dat[3] := PByte(vmdata)[4];
           SyncTemp.config := 0;
           SyncTemp.ftemp := temp.fdat;
           PostMessage(fmMain.Handle, WM_USER + 1, 1, cmd);
         end;
       end;
  $21: begin
         if wSize = 5 then
         begin
           temp.u8dat[0] := PByte(vmdata)[1];
           temp.u8dat[1] := PByte(vmdata)[2];
           temp.u8dat[2] := PByte(vmdata)[3];
           temp.u8dat[3] := PByte(vmdata)[4];
           SyncTemp.config := 0;
           SyncTemp.ftemp := temp.fdat;
           PostMessage(fmMain.Handle, WM_USER + 1, 1, cmd);
         end;
       end;
  $AA: begin
         if wSize = 6 then
         begin
           temp.u8dat[0] := PByte(vmdata)[1];
           temp.u8dat[1] := PByte(vmdata)[2];
           temp.u8dat[2] := PByte(vmdata)[3];
           temp.u8dat[3] := PByte(vmdata)[4];
           SyncTemp.ftemp  := temp.fdat;
           SyncTemp.config := PByte(vmdata)[5];
           PostMessage(fmMain.Handle, WM_USER + 1, 1, cmd);
         end;
       end;
  end;
end;

procedure VMFlashCallBack(fl0, fl : Word; dwErr :DWORD); stdcall;
var procent : integer;
begin
  procent := round(((fl0 - fl) / fl0) * 100);
  fmmain.tomemo('uploading: '+IntToStr(procent)+'%',true);
end;

procedure Tfmmain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if connected = RET_OK then
  begin
    disconnect;
  end;
end;

procedure Tfmmain.FormCreate(Sender: TObject);
begin
  initnetiic(nil,nil,@VM8051Event);
  BtnSetServerValuesClick(Sender);
end;

procedure TfmMain.memoclear;
begin
  memo.Lines.Clear;
end;

procedure TfmMain.tomemo(stxt: String; lastline : Boolean);
begin
  if (lastline) and (Memo.Lines.Count > 0) then
  begin
    Memo.Lines.Strings[Memo.Lines.Count-1] := stxt;
  end else
  begin
    Memo.Lines.Add(stxt);
  end;
end;

procedure Tfmmain.BtnSetServerValuesClick(Sender: TObject);
var stri : string;
begin
  if connected <> RET_OK then
  begin
    stri := ed_server_ip.Text;
    while (pos(' ',stri) > 0) do delete(stri,pos(' ',stri),1);
    sServer := stri;
    wTCPPort := StrToIntDef(ed_server_port.Text,5000);
  end else showmessage('Client ist Connected');
end;

procedure Tfmmain.btn_codeloadedClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := vmcodeloaded(1000);
  if dwErr = RET_OK then
    Memo.Lines.Add('VM CODE is loaded');
  statusbar.panels[0].text := 'VM CODE LOADED: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_GetParamClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucLoad : Byte;
begin
  ucLoad := Byte(cb_runvm.Checked);
  ucLoad := ucLoad shl 1;
  ucLoad := ucLoad or Byte(cb_loadvm.Checked);

  dwErr := vmgetparam(ucLoad, wAddr ,1000);
  if dwErr = RET_OK then
  begin
    ed_eepflashaddr.Text := IntToHex(wAddr,4);
    cb_loadvm.Checked := ((ucLoad and $01) = $01);
    cb_runvm.Checked := ((ucLoad and $02) = $02);
  end;
  statusbar.panels[0].text := 'SAVE VM PARAM: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_get_vmstateClick(Sender: TObject);
var dwErr : DWORD;
    isrunning : Byte;
begin
  dwErr := vmgetstate(isrunning,1000);
  case isrunning of
  0 : lb_vmstate.Caption := 'ABORTED';
  1 : lb_vmstate.Caption := 'RUNNING';
  2 : lb_vmstate.Caption := 'ABORT REQUESTED';
  3 : lb_vmstate.Caption := 'START REQUESTED';
  else lb_vmstate.Caption := 'VM STATE UNKNOWN';
  end;
  statusbar.panels[0].text := 'VM STATE: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_irqresultClick(Sender: TObject);
var dwErr : DWORD;
    irqresult : Byte;
begin
  dwErr := vmirqresult(irqresult,1000);
  if dwerr = RET_OK then
  begin
    case irqresult of
    0 : Memo.Lines.Add('IRQ Request pending or error');
    1 : Memo.Lines.Add('IRQ Data received by VM successfully');
    else lb_vmstate.Caption := 'VM IRQ RESULT UNKNOWN';
    end;
  end else statusbar.panels[0].text := 'VM IRQ RESULT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_LoadFromEEPClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
begin
  wAddr := StrToIntDef('$'+ed_flashaddr.Text,$0100);
  ed_flashaddr.Text := IntToHex(wAddr,4);
  dwErr := vmloadfromeep(wAddr ,1000);
  statusbar.panels[0].text := 'LOAD VM IMAGE FROM EEP: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_LoadToEEPClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucPageSize : Byte;
begin
  wAddr := StrToIntDef('$'+ed_flashaddr.Text,$0100);
  ucPageSize := StrToIntDef(ed_pagesize.Text,32);
  ed_flashaddr.Text := IntToHex(wAddr,4);
  ed_pagesize.Text := IntToStr(ucPageSize);

  if OpenDialog2.Execute then
  begin
    memoclear;
    tomemo('Select Image File:');
    tomemo(OpenDialog2.FileName);
    tomemo('Start flashing image (EEPROM):');
    tomemo('uploading: 0%');
    dwErr := vmloadtoeep_w(PChar(OpenDialog2.FileName),wAddr, ucPageSize, @VMFlashCallBack,1000);
    if dwErr = RET_OK then
      tomemo('Uploading binary file OK')
    else tomemo('Uploading binary file failed');

    statusbar.panels[0].text := 'VM IMAGE TO EEP: '+ GetErrorString(dwErr);
  end;
end;

procedure Tfmmain.btn_read_settingsClick(Sender: TObject);
var dwErr : DWORD;
    pBuf  : array[0..28] of byte;
    pnetconfig : PTNetConfig;
    stri : string;
begin
  dwErr := getnetconfig(pBuf,1000);
  if dwErr = RET_OK then
  begin
    pnetconfig := @pBuf;

    stri := IntToHex(pnetconfig.SHAR[0],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[1],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[2],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[3],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[4],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[5],2);
    lbshar.caption := stri;

    lbgar.Caption := DWORDTosIP(pnetconfig.GAR);
    lbsubr.Caption := DWORDTosIP(pnetconfig.SUBR);
    lbip.Caption := DWORDTosIP(pnetconfig.ip);

    lbtcpport.caption := IntToStr(pnetconfig.TCPPORT);
    lbudpport.caption := IntToStr(pnetconfig.UDPPORT);
    lbvmtcpport.caption := IntToStr(pnetconfig.VMTCPPORT);
    lbvmudpport.caption := IntToStr(pnetconfig.VMUDPPORT);

    lbkpalive.caption := IntToStr(pnetconfig.KPALIVE * 5);
    lbvmkpalive.caption := IntToStr(pnetconfig.VMKPALIVE * 5);
    lbphycheck.caption := IntToStr(pnetconfig.PHYCHECK * 5);
  end;
  statusbar.panels[0].text := 'GET CONFIG: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_SaveParamClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucLoad : Byte;
begin
  wAddr := StrToIntDef('$'+ed_eepflashaddr.Text,$0100);
  ed_eepflashaddr.Text := IntToHex(wAddr,4);

  ucLoad := Byte(cb_runvm.Checked);
  ucLoad := ucLoad shl 1;
  ucLoad := ucLoad or Byte(cb_loadvm.Checked);

  dwErr := vmsetparam(ucLoad, wAddr ,1000);
  statusbar.panels[0].text := 'SAVE VM PARAM: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_vmflashClick(Sender: TObject);
var dwErr, chksum : DWORD;
    wsize : word;
begin
  if OpenDialog2.Execute then
  begin
    memoclear;
    tomemo('Select Image File:');
    tomemo(OpenDialog2.FileName);
    tomemo('Start flashing image:');
    tomemo('uploading: 0%');
    dwErr := vmloadverifycode_w(PChar(OpenDialog2.FileName), chksum, wsize,@VMFlashCallBack,1000);
    if dwErr = RET_OK then
    begin
      tomemo('Image Size: '+IntToStr(wSize));
      tomemo('CheckSum: 0x'+IntToHex(chksum,8));
      tomemo('Uploading binary file OK');
    end else tomemo('Uploading binary file failed');
    statusbar.panels[0].text := 'VM IMAGE UPDATE: '+ GetErrorString(dwErr);
  end;
end;

procedure Tfmmain.btn_vmirqClick(Sender: TObject);
var ucSize, i : WORD;
    svmdata : String;
    vmdata : Array of Byte;
    dwErr   : DWORD;
begin
  svmdata := ed_vmirq.Text;
  ucSize := length(svmdata) DIV 2;
  if ucSize = 0 then Exit;
  setlength(vmdata,ucSize);

  for i := 0 to ucSize -1 do
  begin
    vmdata[i] := StrToInt('$'+copy(svmdata,1,2));
    delete(svmdata,1,2);
  end;
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  if dwErr = RET_OK then Memo.Lines.Add(IntToStr(ucSize)+' Byte(s) written to VM');
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_vmresetClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM RESET: '+ GetErrorString(vmreset(1000));
end;

procedure Tfmmain.btn_vmstartClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM START: '+ GetErrorString(vmstartrequest(1000));
end;

procedure Tfmmain.btn_vmstopClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM STOP: '+ GetErrorString(vmstoprequest(1000));
end;

procedure Tfmmain.Button1Click(Sender: TObject);
begin
  Memo.lines.Clear;
end;

procedure Tfmmain.btn_get_thClick(Sender: TObject);
var ucSize : Byte;
    vmdata : Array of Byte;
    dwErr   : DWORD;
begin
  ucSize := 1;
  setlength(vmdata,ucSize);
  vmdata[0] := $21;
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_thClick(Sender: TObject);
var ucSize : Byte;
    vmdata : Array of Byte;
    dwErr   : DWORD;
    temp : TSingleAndBytes;
begin
  temp.fdat := StrToFloat(ed_th.Text);
  ucSize := 5;
  setlength(vmdata,ucSize);
  vmdata[0] := $11;
  vmdata[1] := temp.u8dat[0];
  vmdata[2] := temp.u8dat[1];
  vmdata[3] := temp.u8dat[2];
  vmdata[4] := temp.u8dat[3];
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_tlClick(Sender: TObject);
var ucSize : Byte;
    vmdata : Array of Byte;
    dwErr   : DWORD;
    temp : TSingleAndBytes;
begin
  temp.fdat := StrToFloat(ed_tl.Text);
  ucSize := 5;
  setlength(vmdata,ucSize);
  vmdata[0] := $10;
  vmdata[1] := temp.u8dat[0];
  vmdata[2] := temp.u8dat[1];
  vmdata[3] := temp.u8dat[2];
  vmdata[4] := temp.u8dat[3];
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_get_tlClick(Sender: TObject);
var ucSize : Byte;
    vmdata : Array of Byte;
    dwErr   : DWORD;
begin
  ucSize := 1;
  setlength(vmdata,ucSize);
  vmdata[0] := $20;
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.ClearMemo1Click(Sender: TObject);
begin
  Memo.Lines.Clear;
end;

procedure Tfmmain.Connect1Click(Sender: TObject);
begin
  if connected <> RET_OK then
  begin
    if connect(PAnsiChar(AnsiString(sServer)),wTCPPort) = RET_OK then
      Caption := 'CONNECTED TO '+sServer
    else Caption := 'UNABLE TO CONNECT TO '+ sServer;
  end;
end;

procedure Tfmmain.Disconnect1Click(Sender: TObject);
begin
  if connected = RET_OK then
  begin
    if disconnect = RET_OK then
      Caption := 'DISCONNECTED';
  end else Caption := 'DISCONNECTED';
end;

function TfmMain.DWORDTosIP(dwIP: DWORD): String;
begin
  Result := IntToStr(Byte(dwIP shr 24))+'.';
  Result := Result + IntToStr(Byte(dwIP shr 16))+'.';
  Result := Result + IntToStr(Byte(dwIP shr 8))+'.';
  Result := Result + IntToStr(Byte(dwIP));
end;

function TfmMain.GetIPBytes(sIP: String; iPosi: Byte): Byte;
var posi  : Byte;
    SubIP : String;
    iIP   : Byte;
begin
  SubIP := '';

  case iposi of
  1: posi := 1;
  2: posi := 5;
  3: posi := 9;
  4: posi := 13;
  5: posi := 17;
  6: posi := 21;
  else posi := 0;
  end;

  if posi > 0 then
  begin
    SubIP := Trim(Copy(sIP,Posi,3));
    if SubIP = '' then
      SubIP := '0';
    SubIP := IntToStr(StrToInt(SubIP));
    iIP   := StrToInt(SubIP);
  end else iIP := 0;
  Result := iIP;
end;

procedure Tfmmain.Exit1Click(Sender: TObject);
begin
  Close;
end;

end.
