#include "vmdevice.h"
#include <stdint.h>
#include <stdio.h>
#include "net.h"
#include "i2c.h"
#include "pcf8574x.h"

static volatile uint8_t ext_event;

void ext_irqhandler (void) __interrupt EXT_VECTOR
{
    ext_event = 1;
    //FEXT is auto-cleared
    //do ....
}

void main(void)
{
    uint8_t value;

    ext_event = 0;

    EXTERNAL_INTERRUPT_FALLING;
    ENABLE_EXTERNAL_INTERRUPT;
    FEXT = 0;
    while(1)
    {
        if (ext_event) {
            ext_event = 0;
            if (io_readport(0x40,&value)) {
                print_u8("IO Interrupt <- Value = 0x%x\r",value);
            } else {
                print_u8("I2C Slave Error - Addr = 0x%x\r",0x40);
            }
        }
    }
}
