#include "vmdevice.h"
#include <stdint.h>
#include "net.h"
#include "i2c.h"

void main(void)
{
    uint8_t loop;

    SLVADDR = 0x40; // Slave address of the IO-Expander

    while(1) {
        if (FNET) {
            TXCH = RXCH;            //Copy RX socket number to the TX socket
            I2CTXLEN = NETRXLEN;    //Set number of bytes to write to the I2C bus

            //Copy data received from RX buffer to output to the I2C TX buffer
            for(loop=0; loop < I2CTXLEN; loop++) {
                I2CTXBUF[loop] = NETRXBUF[loop];
            }
            FNET = 0;       //Clear NET Flag to allow new coming data

            I2CRXLEN = 1;   //Number of bytes to read back from slave
            I2CCON = I2CWR | I2CRS | I2CRD;  //I2C WRITE, REPEATED START , READ

            if (I2CSTAT == I2C_RESULT_OK) {
                NETTXLEN = I2CRXLEN;    //read the actual bytes read from slave

                //Copy data received from I2C RX buffer to output to the NET TX buffer
                for(loop=0; loop < NETTXLEN; loop++) {
                    NETTXBUF[loop] = I2CRXBUF[loop];
                }
                NETCON = NETWR; //Start data transmission
                while(NETSTAT == NET_TRANSMIT_PENDING); //wait until data is sent
            }
        }
    }
}
