#ifndef DS1621_H_INCLUDED
#define DS1621_H_INCLUDED

#define DS1621_DONE     0x80
#define DS1621_THF      0x40
#define DS1621_TLF      0x20
#define DS1621_NVB      0x10
#define DS1621_POL      0x02
#define DS1621_1SHOT    0x01

typedef union {
	float	    fl;
	uint16_t	u16[2];
	uint8_t	    u8[4];
} FL_INT_T;

extern float uitemp_to_float(uint16_t uitemp);
extern uint16_t ftemp_to_u16(float ftemp);
extern uint8_t ds1621_start_convert(uint8_t slvaddr);
extern uint8_t ds1621_stop_convert(uint8_t slvaddr);
extern uint8_t ds1621_read_temp(uint8_t slvaddr, uint16_t * temp16);
extern uint8_t ds1621_read_ftemp(uint8_t slvaddr, float * ftemp);
extern uint8_t ds1621_set_TH(uint8_t slvaddr, uint16_t th);
extern uint8_t ds1621_set_TL(uint8_t slvaddr, uint16_t tl);
extern uint8_t ds1621_get_TH(uint8_t slvaddr, uint16_t * th);
extern uint8_t ds1621_get_TL(uint8_t slvaddr, uint16_t * tl);
extern uint8_t ds1621_read_counter(uint8_t slvaddr, uint8_t * counter);
extern uint8_t ds1621_read_slope(uint8_t slvaddr, uint8_t * slope);
extern uint8_t ds1621_read_hrtemp(uint8_t slvaddr, float * ftemp);
extern uint8_t init_ds1621(uint8_t slvaddr, float tl, float th);
extern uint8_t ds1621_get_config(uint8_t slvaddr, uint8_t * config);
extern uint8_t ds1621_set_config(uint8_t slvaddr, uint8_t config);
extern uint8_t ds1621_reset_flags(uint8_t slvaddr);

#endif // DS1621_H_INCLUDED
