#include "vmdevice.h"
#include <stdint.h>
#include "i2c.h"
#include "pcf8574x.h"

uint8_t io_readport(uint8_t slvaddr, uint8_t * value)
{
    return(i2c_read_8bit(slvaddr,value) == I2C_RESULT_OK);
}

uint8_t io_writeport(uint8_t slvaddr, uint8_t value)
{
    return(i2c_write_8bit(slvaddr,value) == I2C_RESULT_OK);
}

uint8_t io_setpinstate(uint8_t slvaddr, uint8_t pin, uint8_t pinstate)
{
    uint8_t value;

    if (i2c_read_8bit(slvaddr, &value) == I2C_RESULT_OK) {
        if (pinstate) {
            value |= (1 << (pin & 0x07));
            return(i2c_write_8bit(slvaddr,value) == I2C_RESULT_OK);
        } else {
            value &= ~(1 << (pin & 0x07));
            return(i2c_write_8bit(slvaddr,value) == I2C_RESULT_OK);
        }
    } return(0);
}

uint8_t io_getpinstate(uint8_t slvaddr, uint8_t pin, uint8_t * pinstate)
{
    uint8_t value;

    if (i2c_read_8bit(slvaddr, &value) == I2C_RESULT_OK) {
        *pinstate = value & (1 << (pin & 0x07));
        return(1);
    } return(0);
}
